#include <Adafruit_NeoPixel.h>

// Define the pin for the WS2812 LED strip
#define LED_PIN 2

// Define the number of LEDs in the strip
#define LED_COUNT 150
#define CHANNEL 0

// Define the joystick pins
#define X_PIN 12
#define Y_PIN 13
// Define joystick button
#define JOYSTICK_PIN 15

const int BUTTON_PIN = 37;
int b = 0;
int bState = HIGH;
int lastbState = HIGH;
volatile bool buttonInput = false;

// Create an Adafruit_NeoPixel object for the LED strip
Adafruit_NeoPixel strip(LED_COUNT, LED_PIN);
int counter = 0;
unsigned long startTime = millis();
unsigned long currentTime = millis();

void setup() {
  // Initialize serial communication for debugging
  Serial.begin(9600);
  pinMode(JOYSTICK_PIN, INPUT_PULLUP);
  pinMode(BUTTON_PIN, INPUT_PULLUP);
  attachInterrupt(digitalPinToInterrupt(BUTTON_PIN), buttonInterrupt, CHANGE);

  // Initialize the WS2812 LED strip
  strip.begin();
  strip.show();  // Initialize all pixels to off
}

void loop() {

  // Read the joystick values
  int xVal = analogRead(X_PIN);
  int yVal = analogRead(Y_PIN);
  int zVal = digitalRead(JOYSTICK_PIN);
  bState = digitalRead(BUTTON_PIN);
  if (bState != lastbState) {
    if (bState == LOW) {
      b = (b == 1) ? 0 : 1;
    }
    lastbState = bState;
  }
  if (zVal == 0) {
    counter = counter + 1;
    if (counter > 3) {
      counter = 0;
    }
  }
  int i = 0;
  int k = 0;
  // Map the joystick values to the LED colors
  int hue = map(xVal, 0, 4095, 0, 43690);
  int saturation = map(yVal, 0, 4095, 0, 255);
  if (b == 0) {  // Manual mode
  b=0;
    if (counter == 0) {
      for (i = 1; i < 31; i++) {
        strip.setPixelColor(i, strip.ColorHSV(hue, saturation, 6));
      }
      strip.show();
      // Print the joystick and LED values for debugging
      Serial.print(" Hue: ");
      Serial.print(hue);
      Serial.print(" Saturation: ");
      Serial.println(saturation);
      // Delay to prevent flickering
      delay(100);
    }
    else if (counter == 1) {
      for (i = 31; i < 61; i++) {
        strip.setPixelColor(i, strip.ColorHSV(hue, saturation, 6));
      }
      strip.show();
      // Print the joystick and LED values for debugging
      Serial.print(" Hue: ");
      Serial.print(hue);
      Serial.print(" Saturation: ");
      Serial.println(saturation);
      // Delay to prevent flickering
      delay(100);
    } else if (counter == 2) {
      for (i = 61; i < 120; i++) {
        strip.setPixelColor(i, strip.ColorHSV(hue, saturation, 6));
      }
      strip.show();
      // Print the joystick and LED values for debugging
      Serial.print(" Hue: ");
      Serial.print(hue);
      Serial.print(" Saturation: ");
      Serial.println(saturation);
      // Delay to prevent flickering
      delay(100);
    }
  }
  if (b == 1) {   // Automatic mode
      currentTime=millis();
      for (k =1; k<150; k++){
        while(millis()-currentTime<3600000){
          int time = millis()-currentTime;
          strip.setPixelColor(k, strip.ColorHSV(3500, 255, 15));
          strip.show();
          Serial.print("Time until twinkling lights: ");
          Serial.print(3600000-(time/1000));
          Serial.println(" seconds.");
          k++;
            if(buttonInput){
              if (bState != lastbState) {
                if (bState == LOW) {
                  b = (b == 0) ? 0 : 1;
                }
              lastbState = bState;
              }
            buttonInput=false;
            if(buttonInput){
              if (bState != lastbState) {
                if (bState == LOW) {
                  b = (b == 0) ? 0 : 1;
                }
              lastbState = bState;
              }
            }
            return;
            }
          if(b==0){
            return;
          }
        }
          if(b==0){
            return;
          }
        }
        startTime = millis();
        for (i = 1; i < 150; i++) {
          while(millis()-startTime<600000){
            int time02 = millis()-startTime;
            int randomLED = random(strip.numPixels());
            int brightness = random(100);
            strip.setPixelColor(randomLED,strip.ColorHSV(3500, 255, brightness));
            strip.show();
            randomLED = random(strip.numPixels());
            brightness = random(15);
            strip.setPixelColor(randomLED,strip.ColorHSV(3500, 255, brightness));
            strip.show();
            randomLED = random(strip.numPixels());
            brightness = random(15);
            strip.setPixelColor(randomLED,strip.ColorHSV(3500, 255, brightness));
            strip.show();
            randomLED = random(strip.numPixels());
            brightness = random(15);
            strip.setPixelColor(randomLED,strip.ColorHSV(3500, 255, brightness));
            strip.show();
            randomLED = random(strip.numPixels());
            brightness = random(15);
            strip.setPixelColor(randomLED,strip.ColorHSV(3500, 255, brightness));
            strip.show();
            randomLED = random(strip.numPixels());
            brightness = random(15);
            strip.setPixelColor(randomLED,strip.ColorHSV(3500, 255, brightness));
            strip.show();
            randomLED = random(strip.numPixels());
            brightness = random(15);
            strip.setPixelColor(randomLED,strip.ColorHSV(3500, 255, brightness));
            strip.show();
            randomLED = random(strip.numPixels());
            brightness = random(15);
            strip.setPixelColor(randomLED,strip.ColorHSV(3500, 255, brightness));
            strip.show();
            randomLED = random(strip.numPixels());
            brightness = random(15);
            strip.setPixelColor(randomLED,strip.ColorHSV(3500, 255, brightness));
            strip.show();
            randomLED = random(strip.numPixels());
            brightness = random(15);
            strip.setPixelColor(randomLED,strip.ColorHSV(3500, 255, brightness));
            strip.show();
            randomLED = random(strip.numPixels());
            brightness = random(15);
            strip.setPixelColor(randomLED,strip.ColorHSV(3500, 255, brightness));
            strip.show();
            randomLED = random(strip.numPixels());
            brightness = random(15);
            strip.setPixelColor(randomLED,strip.ColorHSV(3500, 255, brightness));
            strip.show();
            randomLED = random(strip.numPixels());
            brightness = random(15);
            strip.setPixelColor(randomLED,strip.ColorHSV(3500, 255, brightness));
            strip.show();
            randomLED = random(strip.numPixels());
            brightness = random(15);
            strip.setPixelColor(randomLED,strip.ColorHSV(3500, 255, brightness));
            strip.show();
             randomLED = random(strip.numPixels());
            brightness = random(15);
            strip.setPixelColor(randomLED,strip.ColorHSV(3500, 255, brightness));
            strip.show();
            randomLED = random(strip.numPixels());
            brightness = random(15);
            strip.setPixelColor(randomLED,strip.ColorHSV(3500, 255, brightness));
            strip.show();
            randomLED = random(strip.numPixels());
            brightness = random(15);
            strip.setPixelColor(randomLED,strip.ColorHSV(3500, 255, brightness));
            strip.show();
            randomLED = random(strip.numPixels());
            brightness = random(15);
            strip.setPixelColor(randomLED,strip.ColorHSV(3500, 255, brightness));
            strip.show();
            randomLED = random(strip.numPixels());
            brightness = random(15);
            strip.setPixelColor(randomLED,strip.ColorHSV(3500, 255, brightness));
            strip.show();
            randomLED = random(strip.numPixels());
            brightness = random(15);
            strip.setPixelColor(randomLED,strip.ColorHSV(3500, 255, brightness));
            strip.show();
            randomLED = random(strip.numPixels());
            brightness = random(15);
            strip.setPixelColor(randomLED,strip.ColorHSV(3500, 255, brightness));
            strip.show();
            randomLED = random(strip.numPixels());
            brightness = random(15);
            strip.setPixelColor(randomLED,strip.ColorHSV(3500, 255, brightness));
            strip.show();
            randomLED = random(strip.numPixels());
            brightness = random(15);
            strip.setPixelColor(randomLED,strip.ColorHSV(3500, 255, brightness));
            strip.show();
            randomLED = random(strip.numPixels());
            brightness = random(15);
            strip.setPixelColor(randomLED,strip.ColorHSV(3500, 255, brightness));
            strip.show();
            randomLED = random(strip.numPixels());
            brightness = random(15);
            strip.setPixelColor(randomLED,strip.ColorHSV(3500, 255, brightness));
            strip.show();
            randomLED = random(strip.numPixels());
            brightness = random(15);
            strip.setPixelColor(randomLED,strip.ColorHSV(3500, 255, brightness));
            strip.show();
            randomLED = random(strip.numPixels());
            brightness = random(15);
            strip.setPixelColor(randomLED,strip.ColorHSV(3500, 255, brightness));
            strip.show();
            randomLED = random(strip.numPixels());
            brightness = random(15);
            strip.setPixelColor(randomLED,strip.ColorHSV(3500, 255, brightness));
            strip.show();
            randomLED = random(strip.numPixels());
            brightness = random(15);
            strip.setPixelColor(randomLED,strip.ColorHSV(3500, 255, brightness));
            strip.show();
            randomLED = random(strip.numPixels());
            brightness = random(15);
            strip.setPixelColor(randomLED,strip.ColorHSV(3500, 255, brightness));
            strip.show();
            randomLED = random(strip.numPixels());
            brightness = random(15);
            strip.setPixelColor(randomLED,strip.ColorHSV(3500, 255, brightness));
            strip.show();
            randomLED = random(strip.numPixels());
            brightness = random(15);
            strip.setPixelColor(randomLED,strip.ColorHSV(3500, 255, brightness));
            strip.show();
            randomLED = random(strip.numPixels());
            brightness = random(15);
            strip.setPixelColor(randomLED,strip.ColorHSV(3500, 255, brightness));
            strip.show();
            randomLED = random(strip.numPixels());
            brightness = random(15);
            strip.setPixelColor(randomLED,strip.ColorHSV(3500, 255, brightness));
            strip.show();
            randomLED = random(strip.numPixels());
            brightness = random(15);
            strip.setPixelColor(randomLED,strip.ColorHSV(3500, 255, brightness));
            strip.show();
            randomLED = random(strip.numPixels());
            brightness = random(15);
            strip.setPixelColor(randomLED,strip.ColorHSV(3500, 255, brightness));
            strip.show();
            randomLED = random(strip.numPixels());
            brightness = random(15);
            strip.setPixelColor(randomLED,strip.ColorHSV(3500, 255, brightness));
            strip.show();
            randomLED = random(strip.numPixels());
            brightness = random(15);
            strip.setPixelColor(randomLED,strip.ColorHSV(3500, 255, brightness));
            strip.show();
            randomLED = random(strip.numPixels());
            brightness = random(15);
            strip.setPixelColor(randomLED,strip.ColorHSV(3500, 255, brightness));
            strip.show();
            randomLED = random(strip.numPixels());
            brightness = random(15);
            strip.setPixelColor(randomLED,strip.ColorHSV(3500, 255, brightness));
            strip.show();
            Serial.print("Time until steady lights: ");
            Serial.print(600000-(time02/1000));
            Serial.println(" seconds.");
            delay(random(1));
            if(buttonInput){
              if (bState != lastbState) {
                if (bState == HIGH) {
                  b = (b == 0) ? 0 : 1;
                }
              lastbState = bState;
              }
            return;
            }
            if(b==0){
              return;
            }
          }
        }
        return;
    }
}

void buttonInterrupt() {
    buttonInput = true;
}
